%define ver       0.3.9.3
%define rel       20100217

%define sel_modn  selinux-policy-addon
%define sel_modv  0.2.2


Summary:          A Multicast Beacon
Name:             dbeacon
Version:          %{ver}
Release:          0.1.%{rel}svn%{?dist}%{?pext}
License:          GPL
Group:            Applications/Internet
Source0:          http://fivebits.net/files/%{name}/%{name}-%{ver}-%{rel}.tar.gz
Source1:          %{name}.init
Source2:          %{name}.sysconfig
Source3:          %{name}.cron
Patch0:           %{name}-0.3.9.2-20080723-config.patch
URL:              http://fivebits.net/proj/%{name}/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Hugo Santos <hugo@fivebits.net>
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service

%description
Dbeacon is a Multicast Beacon written in C++. The main purpose of a
beacon is to monitor other beacons reachability and collect statistics
such as loss, delay and jitter between beacons. Dbeacon supports both
IPv4 and IPv6 multicast, collecting information via ASM and SSM.


%package          selinux
Summary:          SELinux support for %{name}
Group:            System Environment/Base
Requires:         %{name} = %{version}-%{release}
Requires:         %{sel_modn} >= %{sel_modv}
Requires(post):   /sbin/restorecon %{_sbindir}/selinuxenabled /sbin/fixfiles

%description      selinux
This package enables %{name} to work with SELinux.


%prep
%setup -q -n %{name}-%{ver}-%{rel}
%patch0 -p1

# Fix permissions
%{__chmod} -x contrib/*


%build
%{__make} %{?_smp_mflags} \
	CXXFLAGS="${RPM_OPT_FLAGS} -fno-strict-aliasing"


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{cron.d,%{name},sysconfig}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}/matrix
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_mandir}/{man1,man5}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}/data

%{__install} -m 0755 %{name}    ${RPM_BUILD_ROOT}%{_sbindir}

pushd contrib
%{__install} -m 0755 matrix.pl  ${RPM_BUILD_ROOT}%{_datadir}/%{name}/matrix

%{__install} -m 0640 %{name}.conf       ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}
%{__install} -m 0644 matrix.conf.sample ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/matrix.conf

%{__rm}      -f      matrix.* %{name}.conf* index.html
popd

%{__install} -m 0755 %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
%{__install} -m 0644 %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.d/%{name}

%{__install} -m 0644 docs/*.1   ${RPM_BUILD_ROOT}%{_mandir}/man1
%{__install} -m 0644 docs/*.5   ${RPM_BUILD_ROOT}%{_mandir}/man5

%{__cp}      -rpd    contrib    ${RPM_BUILD_ROOT}%{_datadir}/%{name}


%pre
if ! getent group  %{name} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r %{name}
fi
if ! getent passwd %{name} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g %{name}       \
	-d %{_localstatedir}/lib/%{name} \
	-c "Dbeacon Service user"        \
	-s /bin/bash %{name}
fi
exit 0			# Always pass


%post
/sbin/chkconfig --add %{name}

%post selinux
if /usr/sbin/selinuxenabled && [ -e /selinux/policyvers ]; then
  /sbin/fixfiles   -R %{name} restore
  /sbin/restorecon -R %{_sysconfdir}/%{name}
  /sbin/restorecon -R %{_localstatedir}/lib/%{name}
fi


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{name} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{name}
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc Changelog README
%doc docs/{FAQ,PROTOCOL,*.txt}
%{_initrddir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/cron.d/%{name}
%attr(755,root,%{name}) %dir %{_sysconfdir}/%{name}
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/%{name}/matrix.conf
%{_sbindir}/%{name}
%{_datadir}/%{name}
%{_mandir}/man1/%{name}.1*
%{_mandir}/man5/matrix.conf.5*
%attr(755,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}
%attr(755,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}/data

%files selinux
%defattr(-,root,root)


%changelog
* Wed Feb 17 2010 Peter Pramberger <peterpramb@member.fsf.org> - 0.3.9.3-0.1.20100217svn
- New version (0.3.9.3-20100217)

* Fri Jan 09 2009 Peter Pramberger <peterpramb@member.fsf.org> - 0.3.9.2-0.3.20080723svn
- Added cron script for history updates
- Added SELinux package

* Fri Dec 19 2008 Peter Pramberger <peterpramb@member.fsf.org> - 0.3.9.2-0.2.20080723svn
- Added init script and the like

* Wed Jul 23 2008 Peter Pramberger <peterpramb@member.fsf.org> - 0.3.9.2-0.1.20080723svn
- New version (0.3.9.2-20080723)
- Rewritten for buildsystem

* Tue Oct 09 2007 peter.pramberger@member.fsf.org 0.3.9.1-2
- created
